'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

exports.__esModule = true;
exports['default'] = compile;

var _t = require('babel-core');

var _concat$parse$Transformer = require('graphql-parser');

var _import = require('./graphql_to_babel');

var GraphQLToBabel = _interopRequireWildcard(_import);

var transformer = new _concat$parse$Transformer.Transformer(GraphQLToBabel);

function compile(node) {
  _t.types.assertTemplateLiteral(node);

  var strings = node.quasis.map(function (child) {
    return child.value.raw;
  });
  var source = _concat$parse$Transformer.concat(strings);
  var ast = _concat$parse$Transformer.parse(source);

  var replacement = transformer.run(ast, {
    arguments: node.expressions });

  return _t.types.functionExpression(null, [_t.types.identifier('params')], _t.types.blockStatement([_t.types.returnStatement(replacement)]));
}

module.exports = exports['default'];