'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

exports.__esModule = true;

var _dropRightWhile = require('lodash/array/dropRightWhile');

var _dropRightWhile2 = _interopRequireWildcard(_dropRightWhile);

var _t = require('babel-core');

var pack = function pack(arr) {
  return _dropRightWhile2['default'](arr, function (x) {
    return x === null;
  });
};

var ql = function ql(type) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  return _t.types.newExpression(_t.types.memberExpression(_t.types.identifier('GraphQL'), _t.types.identifier(type)), args);
};

var Query = {
  exit: function exit(node) {
    var args = pack([node.arguments ? _t.types.arrayExpression(node.arguments) : null, node.fields ? _t.types.arrayExpression(node.fields) : null, node.fragments ? _t.types.arrayExpression(node.fragments) : null]);

    return ql.apply(undefined, ['Query', _t.types.literal(node.name)].concat(args));
  } };

exports.Query = Query;
var Fragment = {
  exit: function exit(node) {
    var args = pack([node.fields ? _t.types.arrayExpression(node.fields) : null, node.fragments ? _t.types.arrayExpression(node.fragments) : null]);

    return ql.apply(undefined, ['Fragment', _t.types.literal(node.name)].concat(args));
  } };

exports.Fragment = Fragment;
var Field = {
  exit: function exit(node) {
    var args = pack([node.fields ? _t.types.arrayExpression(node.fields) : null, node.fragments ? _t.types.arrayExpression(node.fragments) : null, node.calls ? _t.types.arrayExpression(node.calls) : null]);

    return ql.apply(undefined, ['Field', _t.types.literal(node.name)].concat(args));
  } };

exports.Field = Field;
var Call = {
  exit: function exit(node) {
    return ql('Call', _t.types.literal(node.callee), _t.types.arrayExpression(node.arguments));
  } };

exports.Call = Call;
var Identifier = {
  enter: function enter(node, state) {
    return _t.types.memberExpression(_t.types.identifier('params'), _t.types.identifier(node.name));
  } };

exports.Identifier = Identifier;
var Reference = {
  enter: function enter(node, state) {
    return state.arguments[node.index];
  } };

exports.Reference = Reference;
var Literal = {
  enter: function enter(node) {
    return _t.types.valueToNode(node.value);
  } };
exports.Literal = Literal;